//回调
TalentAllowanceInfoDlg.callBack = function (data) {
    layer.close(data.obj);
    Feng.info(data.msg);
    if (data.code == 200) {
        $("#fileTable").bootstrapTable("refresh", {});
    }
}

//全选
TalentAllowanceInfoDlg.newCheckAll = function (id, obj) {
    var checked = $(obj).is(":checked");
    if (checked) {
        $("#m" + id + " input[name=month]").each(function () {
            $(this).prop("checked", "checked");
        })
    } else {
        $("#m" + id + " input[name=month]").each(function () {
            $(this).removeAttr("checked");
        })
    }
}
//全选
TalentAllowanceInfoDlg.checkAll = function (id) {
    $("#" + id + " input").each(function () {
        $(this).iCheck("check");
    })
}
//反选
TalentAllowanceInfoDlg.unCheckAll = function (id) {
    $("#" + id + " input").each(function () {
        if (this.checked) {
            $(this).iCheck("uncheck");
        } else {
            $(this).iCheck("check");
        }
    })
}
//初始化工作单位表的列
TalentAllowanceInfoDlg.initContractColumns = function () {
    var type = $("#type").val();
    var checkState = $("#checkState").val();
    var concats = $("#concats").val();
    if (type == 1) {
        return [
            {field: 'selectItem', checkbox: false, visible: false},
            {title: '企业名称', field: 'enterpriseName', visible: true, align: 'center', valign: 'middle', width: "120px", 'class': 'uitd_showTip'},
            {title: '合同起始时间', field: 'startTime', visible: true, align: 'center', valign: 'middle', width: "120px", 'class': 'uitd_showTip'},
            {title: '合同截止时间', field: 'endTime', visible: true, align: 'center', valign: 'middle', width: "120px", 'class': 'uitd_showTip'},
            {title: '入职时间', field: 'entryTime', visible: true, align: 'center', valign: 'middle', width: "100px"},
            {title: '本年度工作截止时间', field: 'quitTime', visible: true, align: 'center', valign: 'middle', width: "100px", 'class': 'uitd_showTip'},
            {title: '人才标签', field: 'talentTypeName', visible: true, align: 'center', valign: 'middle', width: "100px", 'class': 'uitd_showTip'},
            {title: '首次来晋行政介绍信时间', field: 'letterTime', visible: true, align: 'center', valign: 'middle', width: "120px"},
                    /*{title: '操作', field: 'id', visible: true, align: 'left', valign: 'middle', width: "120px",
                     formatter: function (value, row, index) {
                     var html = "";
                     if (checkState == 1 || (checkState == 10 && concats.indexOf(value) != -1)) {
                     html = html + "<button type='button' onclick='TalentAllowanceInfoDlg.showEditContractModel(\"" + value + "\")' style='margin-left: 5px' class='btn btn-xs btn-danger'>" +
                     "<i class=\"fa fa-edit\"></i>修改" +
                     "</button>";
                     }
                     html = html + "<button type='button' onclick='TalentAllowanceInfoDlg.showLog(\"" + row.id + "\")' style='margin-left: 5px' class='btn btn-xs btn-success'>" +
                     "<i class=\"fa fa-book\"></i>日志" +
                     "</button>";
                     return  html;
                     }
                     }*/
        ];
    } else {
        return [
            {field: 'selectItem', checkbox: false, visible: false},
            {title: '企业名称', field: 'enterpriseName', visible: true, align: 'center', valign: 'middle', width: "120px", 'class': 'uitd_showTip'},
            {title: '合同起始时间', field: 'startTime', visible: true, align: 'center', valign: 'middle', width: "120px"},
            {title: '合同截止时间', field: 'endTime', visible: true, align: 'center', valign: 'middle', width: "120px", 'class': 'uitd_showTip'},
            {title: '入职时间', field: 'entryTime', visible: true, align: 'center', valign: 'middle', width: "100px"},
            {title: '本年度工作截止时间', field: 'quitTime', visible: true, align: 'center', valign: 'middle', width: "100px"},
                    /*{title: '操作', field: 'id', visible: true, align: 'left', valign: 'middle', width: "120px",
                     formatter: function (value, row, index) {
                     var html = "";
                     if (checkState == 1 || (checkState == 10 && concats.indexOf(value) != -1)) {
                     html = html + "<button type='button' onclick='TalentAllowanceInfoDlg.showEditContractModel(\"" + value + "\")' style='margin-left: 5px' class='btn btn-xs btn-danger'>" +
                     "<i class=\"fa fa-edit\"></i>修改" +
                     "</button>";
                     }
                     html = html + "<button type='button' onclick='TalentAllowanceInfoDlg.showLog(\"" + row.id + "\")' style='margin-left: 5px' class='btn btn-xs btn-success'>" +
                     "<i class=\"fa fa-book\"></i>日志" +
                     "</button>";
                     return  html;
                     }
                     }*/
        ];
    }
}

//初始化项目表的列
TalentAllowanceInfoDlg.initProjectColumns = function () {
    return [
        {field: 'selectItem', checkbox: false, visible: false},
        {title: '核查项目名称', field: 'projectName', visible: true, align: 'center', valign: 'middle', width: "15%", 'class': 'uitd_showTip'},
        {title: '详情（填写完请按右侧的保存按钮）', field: 'months', visible: true, align: 'center', valign: 'middle', width: "45%",
            formatter: function (value, row, index) {
                var allowanceType = $("#allowanceType").val();
                var html = "";
                if (row.project == 4 && allowanceType == 2) {
                    html = TalentAllowanceInfoDlg.createDaySelector(row.id, value);
                } else {
                    html = TalentAllowanceInfoDlg.createMonthSelector(row.id, value);
                }
                return html;
            }
        },
        {title: '备注', field: 'description', visible: true, align: 'center', valign: 'middle', width: "25%",
            formatter: function (value, row, index) {
                var html = '<textarea id="d' + row.id + '" class="form-control">' + (value ? value : "") + '</textarea>';
                return html;
            }
        },
        {title: '操作', field: 'project', visible: true, align: 'left', valign: 'middle', width: "15%",
            formatter: function (value, row, index) {
                var allowanceType = $("#allowanceType").val();
                var butHtml = "";
                if (row.isEdit == 1) {
                    /*butHtml = butHtml + "<button type='button' data-value='" + (row.description ? row.description : "") + "' onclick=\"TalentAllowanceInfoDlg.showEditProjectModal('" + row.project + "','" + row.id + "','" + row.enterpriseId + "','" + row.months + "','" + row.days + "',this)\" style='margin-left: 5px' class=\"btn btn-xs btn-danger tips\">" +
                     "<i class=\"fa fa-edit\"></i>修改</button>";*/
                    butHtml = butHtml + "<button type='button' onclick=\"TalentAllowanceInfoDlg.saveProjectData('" + row.id + "','" + row.project + "','" + allowanceType + "')\" style='margin-left: 5px' class=\"btn btn-xs btn-danger tips\">" +
                            "<i class=\"fa fa-edit\"></i>保存</button>";
                }
                butHtml = butHtml + "<button type='button' onclick='TalentAllowanceInfoDlg.showLog(\"" + row.id + "\")' style='margin-left: 5px' class='btn btn-xs btn-success'><i class=\"fa fa-book\"></i>日志</button>";
                return butHtml;
            }
        }
    ];
}

TalentAllowanceInfoDlg.createDaySelector = function (id, selectDays) {
    var dayArr = selectDays ? selectDays.split(",") : [];
    var tmpKv = {};
    for (var d = 0; d < dayArr.length; d++) {
        var kv = dayArr[d].split("=");
        tmpKv["m" + kv[0]] = kv[1];
    }
    var html = '<div id="m' + id + '" class="day-selector"><span style="color:red;">*填写对应月份打卡天数，没有填写则记为0天</span><ul>';
    var bigMonths = [1, 3, 5, 7, 8, 10, 12];
    for (var m = 1; m <= 12; m++) {
        var month = m < 10 ? "0" + m : m;
        var day = tmpKv["m" + month] ? tmpKv["m" + month] : "";
        var maxDay = bigMonths.indexOf(m) > -1 ? 31 : (m != 2 ? 30 : 29);
        html += '<li><label>' + m + '月</label><input type="number" name="day" class="form-control" max="' + maxDay + '" min="0" num="' + month + '" value="' + day + '"></li>';
    }
    html += '</ul></div>'
    return html;
}

TalentAllowanceInfoDlg.createMonthSelector = function (id, selectMonths) {
    var monthArr = selectMonths ? selectMonths.split(",") : [];
    var html = '<div id="m' + id + '" class="month-selector"><ul><li><input type="checkbox" onchange="TalentAllowanceInfoDlg.newCheckAll(' + id + ',this)">全选</li>';
    for (var m = 1; m <= 12; m++) {
        var month = m < 10 ? "0" + m : m;
        var checked = "";
        if (monthArr.indexOf(month.toString()) > -1) {
            checked = "checked";
        }
        html += '<li><input type="checkbox" name="month" value="' + month + '" ' + checked + '>' + month + '月</li>';
    }
    html += '</ul></div>'
    return html;
}

/**
 * 初始化附件类别表的列
 */
TalentAllowanceInfoDlg.initFileTypeColumn = function () {
    return [
        {field: 'selectItem', checkbox: false, visible: false},
        {title: '名称', field: 'name', visible: true, align: 'center', valign: 'middle', width: "30%", 'class': 'uitd_showTip',
            formatter: function (value, row, index) {
                if (row.must == 1) {
                    return '<i class="fa fa-paste"></i><span style="font-weight:bold;color:red;font-size:14px;font-family:宋体"> * </span> ' + value;
                }
                if (row.must == 2) {
                    return '<i class="fa fa-paste"></i>' + value;
                }
            }
        },
        {title: '模板', field: 'templateUrl', visible: true, align: 'center', valign: 'middle', width: "8%",
            formatter: function (value, row, index) {
                if (value == null || value == '' || value == 'null') {
                    return '无';
                }
                return "<button type='button' onclick=\"Feng.downloadFile('" + row.id + "',3)\" style='margin-right: 10px' class=\"btn btn-xs btn-primary\">" +
                        "<i class=\"fa fa-download\"></i>下载" +
                        "</button>";
            }
        },
        {title: '备注', field: 'description', visible: true, align: 'center', valign: 'middle', width: "52%", 'class': 'uitd_showTip'},
        {title: '操作', field: 'id', visible: true, align: 'center', valign: 'middle', width: "10%",
            formatter: function (value, row, index) {
                var files = $("#files").val();
                var checkState = $("#checkState").val();
                var type = $("#type").val();
                if (checkState == 1 || (checkState == 10 && files.indexOf(row.id) != -1) || (type == 5 && checkState == 8 && files.indexOf(row.id) != -1)) {
                    return "<button type='button' onclick=\"TalentAllowanceInfoDlg.checkFile(this,'" + value + "','" + null + "')\" style='margin-right: 10px' class=\"btn btn-xs btn-info\">" +
                            "<i class=\"fa fa-upload\"></i>添加" +
                            "</button>";
                } else {
                    return "";
                }

            }
        }
    ]
};

TalentAllowanceInfoDlg.showLog = function (id) {
    layer.open({
        type: 1,
        title: "日志",
        fixed: false,
        content: '<table id="' + id + '"></table>',
        area: ['80%', '80%'],
        maxmin: true,
        success: function (layero, index) {
            $('#' + id).bootstrapTable({
                url: Feng.ctxPath + "/common/api/getJbtCheckLog",
                method: 'POST',
                contentType: "application/x-www-form-urlencoded; charset=UTF-8",
                search: false, // 是否显示表格搜索，此搜索是客户端搜索，不会进服务端
                showRefresh: false, // 是否显示刷新按钮
                clickToSelect: true, // 是否启用点击选中行
                singleSelect: true, // 设置True 将禁止多选
                striped: true, // 是否显示行间隔色
                pagination: false, // 设置为 true 会在表格底部显示分页条
                paginationHAlign: "left",
                paginationDetailHAlign: "right",
                sidePagination: "server", // 设置在哪里进行分页，可选值为 'client' 或者 'server'
                showColumns: false,
                queryParams: function (params) {
                    return {"type": CONFIG.project_jbt, "mainId": $("#id").val(), "typeFileId": id, "active": 1}
                },
                columns:
                        [
                            {title: '步骤', field: 'stepName', visible: true, align: 'center', valign: 'middle', width: "10%",
                                formatter: function (value, row, index) {
                                    return "" + value;
                                }
                            },
                            {title: '操作人', field: 'createUser', visible: true, align: 'center', valign: 'middle', width: "15%"},
                            {title: '操作时间', field: 'createTime', visible: true, align: 'center', valign: 'middle', width: "20%"},
                            {title: '描述', field: 'description', visible: true, align: 'center', valign: 'middle', width: "45%",
                                formatter: function (value, row, index) {
                                    return '<span data-toggle="tooltip" title="' + value + '">"' + value + '"</span>';
                                }
                            }
                        ]
                ,
                onPostBody: function () {
                    $('#' + id + "td.uitd_showTip").bind("mouseover", function () {
                        var htm = $(this).html();
                        $(this).webuiPopover({title: '详情', content: htm, trigger: 'hover'}).webuiPopover('show');
                    });
                }
            });
        }
    });
}